
package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.Rolle;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractRolleEdit {

  @Inject
  protected RolleDAO dao;

  @Inject
  protected RolleExtendedDAO extendedDao;

  public void delete(Rolle entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Rolle entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Rolle entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Rolle getAttachedEntity(Rolle entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Rolle getAttachedAndRefreshedEntity(Rolle entity) {
    return dao.refresh(entity);
  }
}
